#region Using directives
using System;
using UAManagedCore;
using OpcUa = UAManagedCore.OpcUa;
using QPlatform.HMIProject;
using QPlatform.OPCUAServer;
using QPlatform.UI;
using QPlatform.NativeUI;
using QPlatform.CoreBase;
using QPlatform.NetLogic;
using System.Collections.Generic;
using System.Text;
using QPlatform.Alarm;
using QPlatform.EventLogger;
using QPlatform.Store;
using QPlatform.SQLiteStore;
using QPlatform.CommunicationDriver;
using QPlatform.Modbus;
using QPlatform.Recipe;
#endregion

public class AudiEventLogger : BaseNetLogic, IUAEventObserver
{
    public override void Start()
    {
        var serverObject = LogicObject.Context.GetObject(OpcUa.Objects.Server);
        //eventRegistration = serverObject.RegisterUAEventObserver(this, UAManagedCore.OpcUa.ObjectTypes.AuditNodeManagementEventType);
    }

    public override void Stop()
    {
        // Insert code to be executed when the user-defined logic is stopped
    }

    public void OnEvent(IUAObject eventNotifier, IUAObjectType eventType, IReadOnlyList<object> eventData, ulong senderId)
    {
        StringBuilder builder = new StringBuilder();
        builder.Append($"Event of type {eventType.BrowseName} triggered");

        var eventArguments = eventType.EventArguments;
        foreach (var eventField in eventArguments.GetFields())
        {
            var fieldValue = eventArguments.GetFieldValue(eventData, eventField);
            if (eventField == "NodesToAdd")
            {
                var nodesToAdd = (Struct[])fieldValue;
                var childNode = nodesToAdd[0].Get(2);
                var node = LogicObject.Context.GetNode((NodeId)childNode);
                builder.Append($"\t{eventField} = {node?.BrowseName ?? "null"}");
            }
            else
            {
                builder.Append($"\t{eventField} = {fieldValue?.ToString() ?? "null"}");
            }
        }

        builder.Append("\n");
        Log.Info(builder.ToString());
    }

   // private IEventRegistration eventRegistration;
}
