#region StandardUsing
using System;
using QPlatform.CoreBase;
using QPlatform.HMIProject;
using UAManagedCore;
using OpcUa = UAManagedCore.OpcUa;
using QPlatform.NetLogic;
using QPlatform.OPCUAServer;
using QPlatform.UI;
using QPlatform.Store;
using QPlatform.SQLiteStore;
using QPlatform.CommunicationDriver;
using QPlatform.Modbus;
using QPlatform.Recipe;
#endregion

public class EditUserDetailPanelLogic : QPlatform.NetLogic.BaseNetLogic
{
	[ExportMethod]
	public void SaveUser(string username, string password, string locale, out NodeId result)
	{
        result = NodeId.Empty;

		if (string.IsNullOrEmpty(username))
		{
			Log.Error("Cannot create user with empty username");
			return;
		}

        result = ApplyUser(username, password, locale);
	}

	private NodeId ApplyUser(string username, string password, string locale)
	{
		var users = GetUsers();
		if (users == null)
		{
			Log.Error("Unable to get users");
			return NodeId.Empty;
		}
		var user = users.Get<QPlatform.Core.User>(username);
		user.Password = password;
		user.LocaleIds = new string[] { locale };

		return user.NodeId;
	}

	private IUANode GetUsers()
	{
		var resolvedNode = LogicObject.Context.ResolvePath(LogicObject, "{Users}@Jump");
		if (resolvedNode == null)
			return null;
		if (resolvedNode.Nodes.Count == 0)
			return null;

		return resolvedNode.Nodes[0];
	}
}
